#include "commfunctions.h"
#include "types.h"

//int32_t rawByteArrayToInt32(uint8_t data[], uint8_t offset) 
//{
//    int8_t i;
//    int32_t temp=0;
//    
//    for(i=0; i<4; i++)
//	   temp = (temp + (data[i+offset]& 0xFF)) << 8;
//    return (temp>>8);
//}

int32_t rawByteArrayToInt32(uint8_t data[], uint8_t offset) 
{
	return data[offset]<<24 | (data[offset+1]&0xff)<<16 | (data[offset+2]&0xff)<<8 | (data[offset+3]&0xff);	
}


void int32ToRawByteArray(int32_t data, uint8_t buffpos, uint8_t buff[]) 
{
    buff[buffpos++] = (uint8_t)(data>>24 & 0xFF);
    buff[buffpos++] = (uint8_t)(data>>16 & 0xFF);
    buff[buffpos++] = (uint8_t)(data>>8 & 0xFF); 
    buff[buffpos++] = (uint8_t)(data & 0xFF);
}

//int16_t rawByteArrayToInt16(uint8_t data[], uint8_t offset) 
//{
//	int8_t i;
//    int32_t temp=0;
//	
//    for(i=0; i<2; i++)
//		temp = (temp + (data[i+offset]& 0xFF)) << 8;
//	return (int16_t)(temp>>8);
//}

int16_t rawByteArrayToInt16(uint8_t data[], uint8_t offset) 
{
	return data[offset+0]<<8 | (data[offset+1]&0xff);	
}

void int16ToRawByteArray(int16_t data, uint8_t buffpos, uint8_t buff[]) 
{
    buff[buffpos++] = (uint8_t)(data>>8 & 0xFF);
    buff[buffpos++] = (uint8_t)(data & 0xFF);
}

int8_t rawByteArrayToInt8(uint8_t data[], uint8_t offset) 
{
    return (int8_t)(data[offset]);
}

void int8ToRawByteArray(int8_t data, uint8_t buffpos, uint8_t buff[]) 
{
    buff[buffpos++] = (uint8_t)(data & 0xFF);
}


float rawByteArrayToFloat(uint8_t data[], uint8_t offset) 
{
    uint8_t i;  
    float tmpBuffer = 0.0f;
    char  *buffer = (char*)&tmpBuffer;
    
    for(i=0; i<4; i++)
    {
        buffer[i] = data[i+offset];
    }
    
    return *((float*)&(buffer[offset]));
}

void floatToRawByteArray(float data, uint8_t buffpos, uint8_t buff[]) 
{
    float_to_raw ufloat;
    ufloat.value = data;
    buff[buffpos++] = (uint8_t)ufloat.raw[0];
    buff[buffpos++] = (uint8_t)ufloat.raw[1];
    buff[buffpos++] = (uint8_t)ufloat.raw[2];
    buff[buffpos++] = (uint8_t)ufloat.raw[3];
          
}


/* Float to Raw Byte und umgekehrt */
//
//float tmpBuffer[20];
//char* buffer = (char*)tmpbuffer;
//
//
//Jetzt hast du ein char Array bei dem du mittels
//   (float*)&(buffer[NrFloat*sizeof(float)])
//
//reinindizieren kannst, und wo das Alignment fr float
//passen msste.
//
//Bist du sicher, da der PC das binre Float-Format auch richtig
//interpretiert?
//
//In C kannst du es auf jeden Fall so machen:
//
//typedef _float_to_raw union {
//   float    v;
//   char     r[sizeof (float)];
//} float_to_raw;
//
//float_to_raw R;
//R.v = <float-wert>;
//// In R.r steht jetzt der float-Wert als Bytefolge
